"PackageLoader fileInPackage: #Compiler!"


File subclass: #StmSourceFile
	 instanceVariableNames: ''
	 classVariableNames: ''
	 poolDictionaries: ''
	 category: 'Iroduke'!

!StmSourceFile class methodsFor: 'filing'!

tempFilenameForBase: aString endingWith: suffix
	^'StmOut/%1.stm%2' bindWith: aString with: suffix!

ifLine: aLine isObjCFormat: aBlock otherwise: anotherBlock
	| char |
	char := aLine at: 1.
	(((char = $-) or: [ char = $+ ]) and: [
		((aLine at: 3) = $() or: [ (aLine at: 3) = $G ] ])
		ifTrue: aBlock ifFalse: anotherBlock.
!

fileIn: fileName
"
* [07/06/04 18:05:30 +0800]
	This needs to compare dates on the generated file vs. TM file
* [07/13/04 01:31:46 +0800]
	We need to #fileIn from a String.... .tm.st is kinda ugly =)
"

	| tempFn tm st |

	tm := self name: fileName.
	st := tm smalltalkContents.

	tempFn := self tempFilenameForBase: tm className endingWith: '.st'.
	(FileStream open: tempFn mode: 'w') nextPutAll: st; nl; close.

	FileStream fileIn: tempFn.

	"STInST.STFileInParser parseSmalltalk: st onError: [ ObjectMemory quit ]."

	"Transcript show: ('Loading ', fileName); nl.
	self evalString: st
		 to: nil
		 ifError: [ :fname :line :error |
			 Transcript show: ('%1:%2: %3' bindWith: fileName with: line with: error); nl.
			 Transcript show: st; nl.
			 ObjectMemory quit ]."
!

!!

!StmSourceFile methodsFor: 'accessing and naming'!

className
	^File stripPathFrom: self stripExtension!

!!

!StmSourceFile methodsFor: 'parsing'!

combinedContents
"
* [07/06/04 18:24:01 +0800]
	Recreate a TM file...
"
	^nil!

smalltalkContents
	| fs out line char |

	fs := FileStream open: (self name) mode: 'r'.
	out := WriteStream on: String new.

	[ fs atEnd ] whileFalse: [
		line := fs upTo: Character nl.
		line isEmpty ifFalse: [
			char := line at: 1.
			((char = $#) or: [ (((char = $-) or: [ char = $+ ]) and: [
				((line at: 3) = $() or: [ (line at: 3) = $G ] ]) ])
				ifTrue: [ fs upToAll: '}!' ]
				ifFalse: [ out nextPutAll: line ].
			].
		out nl.
		].

	fs close.
	^out contents.
!

objcContent
!

!!

!StmSourceFile methodsFor: 'parsing-old'!

methodImplCategory: aString on: stream
	| iv |
	iv := aString indexOf: '''*''' matchCase: false startingAt: 1.
	iv do: [ :i |
		((aString at: i) = $')
	   ifTrue: [ ]
	   ifFalse: [ stream nextPut: (aString at: i) ]
		].
!

splitStream: stream
	| ns i char line nline st m h superclassName className taken |

	"TODO ehh instead of splitting, we can have fileIn: for .tm files easily...
	 then avoids the 'compile-check' step or touch requirement"

	st := WriteStream on: String new.
	m := WriteStream on: String new.
	h := WriteStream on: String new.

"	line := ''.
	[ '*subclass:*' match: line ] whileFalse: [
		line := stream nextLine.
		m nextPutAll: line; nl.
		]."

	superclassName := stream upToAll: ' subclass:'.
	('Object' match: superclassName) ifTrue: [ superclassName := 'STObject' ].
	stream upTo: $#.
	className := stream nextLine.

	stream reset.

	h nextPutAll: '// -*- mode: objc -*-'; nl; nl.
	h nextPutAll: ('@interface %1 : %2' bindWith: className with: superclassName); nl.

	"h nl; nextPutAll: '// Smalltalk'; nl; nl.
	i := (Class metaclassFor: className).
	i methodDictionary do: [ :key |
		h nextPutAll: ('- %1;' bindWith: (i at: key) selector); nl ]."

	h nl; nextPutAll: '// Objective-C'; nl; nl.

	m nextPutAll: '#include <StmOut/StmImpl.h>'; nl; nl.
	m nextPutAll: ('@implementation %1' bindWith: className); nl.

	"TODO: store methods, categorize, and export ST method names... nope, keyword"

	i := 1.
	[ stream atEnd ] whileFalse: [
		taken := false.
		line := stream nextLine.

		line isEmpty
			ifTrue: [ ]
			ifFalse: [

"
* [07/11/04 03:23:20 +0800]
	Get className from the subclass: line. Do it multiple times, and sort methods
 by methodsFor: lines. Also #method should be automatic through methodDict.
 Also synchronize @implementation <className> (Category) with methodsFor: aCategoryName.

* [07/11/04 11:18:44 +0800]
	Parsing problem: Without a -Globals {}! statement, the .st code will not be collected
 properly... quite strange.
"
					"('* subclass: *' match: line) ifTrue: [
					]."

				('!* methods>_<For: *!' match: line) ifTrue: [
					m nextPutAll: ('@implementation %1 (' bindWith: className).
					self methodImplCategory: line on: m.
					m nextPut: $); nl; nl ].

				(line match: '!>_<!') ifTrue: [ m nextPutAll: '@end'; nl; nl ].

				('#include *' match: line) ifTrue: [ h nextPutAll: line; nl.
													 i := i + 1. taken := true ].

				"TODO: Replace me! use semicolon to dump in .h"
				('#method *' match: line) ifTrue: [
					h nextPutAll: (line copyFrom: 8 to: (line size)); nextPut: $;; nl.
					i := i + 1. taken := true ].


char := line at: 1.
			(((char = $-) or: [ char = $+ ]) and: [
				(((line at: 3) = $() or: [ (line at: 3) = $G ]) ]) ifTrue: [
					[ :v | m nextPutAll: v; nl. h nextPutAll: v; nl ] value:
						('#line %1 "%2"' bindWith: i with: self name).

						i := i + 1.
						('- Global' match: line)
							ifTrue: [ "m nl; nextPutAll: 'struct'; nl; nextPut: ${; nl" ]
							ifFalse: [ m nextPutAll: line; nl; nextPut: ${; nl.
									   h nextPutAll: line; nextPut: $;; nl ].

						nline := nil.
						[ :rs |
							[ rs atEnd ] whileFalse: [
								ns := rs nextLine.
								('{' match: ns) ifFalse: [
									m nextPutAll: ns; nl.
									nline := ns.
									i := i + 1.
									].
								].
							] value: (ReadStream on: (stream upToAll: '}!')).

						i := i + 1.

						('- Global' match: line)
							ifTrue: [ "m nextPutAll: '} Global;'; nl; nl" m nl ]
							ifFalse: [
								nline isNil ifFalse: [
									('*return *' match: nline) ifFalse: [
										m nextPut: Character tab.
										m nextPutAll: 'return self;'; nl.
										].
									].
								m nextPut: $}; nl; nl.
								].

						taken := true.
						].
					].

		taken ifFalse: [ st nextPutAll: line; nl ].
		i := i + 1.
		].

{h. m} do: [ :n | n nextPutAll: '@end'; nl; nl ].

	self writeFileContents: { '.h' -> h. '.m' -> m }." '%1.st' -> st }."

	"Transcript show: 'Objective-C Header: '; nl; nextPutAll: h contents; nl.
	Transcript show: 'Objective-C Source: '; nl; nextPutAll: m contents; nl."
	"Transcript show: 'Smalltalk: '; nl; nextPutAll: smalltalk; nl."
!

!!

" would look nice as SourceFileTM... MakefileTM ... "

!StmSourceFile methodsFor: 'writing'!

writeFileContents: assocs
	"This seems very useful as a general purpose.. put in FileStream+KernelAdditions"
	| out |
	assocs do: [ :a |
		out := FileStream open: (StmSourceFile tempFilenameForBase: self className endingWith: a key)
mode: 'w'.
		out nextPutAll: a value contents.
		out close.
		].
!

!!

